#include <iostream>
#include <list>

#include "graph.h"

using namespace std;

// Initialize graph
Graph::Graph(int vertices) {
    numVertices = vertices;
    // Note that this is creating 'vertices' number of lists
    adjLists = new list<int>[vertices];
    visited = new bool[vertices];
}

// Add edges
void Graph::addEdge(int src, int dest) { adjLists[src].push_front(dest); }

// DFS algorithm
void Graph::DFS(int vertex) {
    visited[vertex] = true;
    // Get the list for this particular vertex
    list<int> adjList = adjLists[vertex];

    cout << vertex << " ";

    list<int>::iterator i;
    for (i = adjList.begin(); i != adjList.end(); ++i)
        if (!visited[*i]) DFS(*i);
}
